############################################################################
#
#       Project		evaluate float function using MODIFIED gpquick-2.1,
# 			using Intel AVX-512 C/Unix/etc $Revision: 1.8 $ 
# 			Needs newish GCC
#	    
#       Author		W.B.Langdon
#
#	Created		22 Nov 2018, based upon bool.make Revision: 1.3
# 									   
#	Modifications:  
#
#	Module:         avx.make
#
#	Description:          
#
#	Notes		ensure pch.h contain #define UNIX
#			#define MULTREE
#
############################################################################

NAME 	= GPavx
OBJS 	= gp.o	avx.o	stats.o chrome.o   rand_tree.o	selector.o
LIBS 	= -lm
CC 	= g++
COMPILE = $(CC) -c $(CFLAGS)
CFLAGS 	= -O3 -DNDEBUG
#CFLAGS 	= -g
#CFLAGS = -g3 -Wall -check -pg
CFLAGS 	+= -pthread 
CFLAGS 	+= -fmax-errors=1
#french-602-2 scl enable devtoolset-7 bash; tcsh; make -f avx.make V=1
#try /opt/rh/devtoolset-7/root/usr/bin/g++ (GCC 7.3.1) for avx512f
SSE     = -mavx512f -DAVX
#SSE	= -march=native -mtune=native
LINK 	= $(CC) -o 
#https://stackoverflow.com/questions/1662909/undefined-reference-to-pthread-create-in-linux
LDFLAGS =  -g -pthread -lpthread


$(NAME):$(OBJS) 
	$(LINK) $(NAME) $(LDFLAGS) $(OBJS) $(LIBS)

#C++ source files

gp.o:	gp.cc pch.h chrome.h selector.h avx.h time.h gp.h trace.h test.h
	$(COMPILE) gp.cc

avx.o:	avx.cc pch.h chrome.h selector.h avx.h primitiv.h test.h avx.fitness.cc
	$(COMPILE) $(SSE) avx.cc

#turned off -DDEPTH_STATS
stats.o:	stats.cc pch.h chrome.h selector.h avx.h gp.h
	$(COMPILE) stats.cc

chrome.o:	chrome.cxx pch.h chrome.h selector.h avx.h
	$(COMPILE) chrome.cxx

rand_tree.o:	rand_tree.cc pch.h chrome.h selector.h avx.h
	$(COMPILE) rand_tree.cc

selector.o:	selector.cxx pch.h selector.h
	$(COMPILE) selector.cxx
